extension StringWhen on String {
  T when<T>(Map<String, T Function()> cases, {T Function() any}) {
    if (cases.containsKey(this)) {
      return cases[this]();
    }
    if (any != null) {
      return any();
    }
    throw Exception('String.when failed, found no match for: $this');
  }
}
